<template>
  <div class=" page">
    <div v-if="isLoading" class="py-5 text-center">
      <vue-loaders class="py-5" name="ball-beat" color="#fa8357" scale="2"></vue-loaders>
    </div>
    <div v-else>
      <div class="py-5">
        <h3 class="text-uppercase text-center text-white font-weight-bolder mt-5">PASSWORD RESET</h3>
        
        <h4 v-if="accountNotFound" class="text-center text-danger p-4">
          Impossible de trouver le compte. Veuillez bien vérifier le lien de réinitialisation de mot de passe dans 
          votre boite mail. Merci
        </h4>
        

        <div v-if="!isConfirm" class="card bg-white p-3 p-md-5 col-sm-4 mx-auto rounded-lg mt-5">
          <form class="" accept-charset="utf-8" @submit="resetMyPassword">
            <div class="alert alert-danger text-center mb-4" v-if="errorMessage">{{errorMessage}}</div>
            
            <div :class="(checkReset ? 'was-validated ' : '') + ' mb-4'">
              <strong class="mb-3">New Password <sup class="text-danger">*</sup></strong>
              <div class="input-group">
                <input :type="inputPwd ? 'password' : 'text'" minlength="8" class="form-control form-control-min"
                  title="At least 8 characters, a number, an upper case letter, a lower case letter and a special character"
                  pattern="(?=.*\d)(?=.*[a-z])(?=.*[A-Z])(?=.*[-+!#*$@%_]).{8,}"
                  required v-model="password" placeholder="Enter your new Password">

                <div class="input-group-prepend  btn btn-outline-secondary" @click="inputPwd=!inputPwd" >
                  <span class="" id="inputGroupPrepend">
                    <i v-if="inputPwd==true" class="fa fa-eye"></i>
                    <i v-else class="fa fa-eye-slash"></i>
                  </span>
                </div>
                <div class="invalid-feedback">
                  Enter your new Password
                </div>

              </div>
            </div>


            <div v-if="password.length>7" class="mb-4">
              <strong class="mb-3">Confirme Password <sup class="text-danger">*</sup></strong>
              <div class="input-group">
                <input :type="inputConfPwd ? 'password' : 'text'" minlength="8" :class="'form-control form-control-min ' + (pwdNotValide==true ? 'is-invalid ' : 'is-valid ') "
                title="At least 8 characters, a number, an upper case letter, a lower case letter and a special character" v-on:input="comparePwd"
                pattern="(?=.*\d)(?=.*[a-z])(?=.*[A-Z])(?=.*[-+!#*$@%_]).{8,}"
                required v-model="confPass" placeholder="Confirme your Password">

                <div class="input-group-prepend  btn btn-outline-secondary" @click="inputConfPwd=!inputConfPwd" >
                  <span class="" id="inputGroupPrepend">
                    <i v-if="inputConfPwd==true" class="fa fa-eye"></i>
                    <i v-else class="fa fa-eye-slash"></i>
                  </span>
                </div>
                <div v-if="pwdNotValide==true" class="invalid-feedback">
                  Mot de passe non conforme
                </div>
                <div v-else class="invalid-feedback">
                  Confirme your Password
                </div>
              </div>
              
              
            </div>
            <div class="d-grid gap-2 my-4" @click="checkReset=true">
              <button type="submit" class="btn-block text-white btn btn-primary">Réinitialiser mon mot de passe</button>
            </div>
          </form>
        </div>

        <h4 v-else class="text-center text-info p-4">
          Votre mot de passe vient d'être réinitialiser. Vous pouvez désormais vous connecter.
          <br><br><br>
          <span @click="next('/')" class="btn btn-primary">Me connecter</span>
        </h4>
      </div>
    </div>
  </div>
</template>
<script lang="ts">
// const CryptoJS = require("crypto-js");
import CryptoJS from 'crypto-js';

export default {
	data(){
		return {
      isLoading: false,
      user: {},

      password: '',
      confPass: '',
      pwdNotValide: true,
      
      curStep: 1,
      feedBack: '',

      errorMessage: '',
      accountNotFound: false,
      accountConfSucc: false,
      isConfirm: false,
      checkReset: false,

      inputConfPwd: true,
      inputPwd: true,

      
		}
	},
	async mounted(){
    if(this.$route.params.token && this.$route.params.token.length > 1){
      // this.loadMe();
      console.log("Hallo")
    } else {
      this.accountNotFound = true;
    }
	},
	methods: {
    resetMyPassword(e){
      e.preventDefault();

      if(this.password != this.confPass){
        return this.errorMessage = "Mot de passe non conforme!";

      } else {
        this.isLoading = true;
        const userData = {
          password: this.encryptPassword(this.password),
          token: this.$route.params.token
        }

        this.$service.put("users/reset-password/", userData, (data) => {
          this.isLoading=false;
          // console.log("Response : ",data);

          if(data.status == 404){
            this.$alertify.error(""+data.message);
            this.errorMessage = data.message;
            this.accountNotFound = true;

          } else {

            if(data.status == 409){
              
              this.$alertify.warning(""+data.message);
              this.errorMessage = data.message;

            } else {

              if(data.status == 200){
                this.isConfirm = true;
                this.accountNotFound = false;
                this.$alertify.alert('Password is up to date!', 
                  `Votre mot de passe a été réinitialisé avec succès. Vous pouvez vous connecter!`
                );
                
              }
              
            }

          }

        });

      }

    },
    encryptPassword(password){
      return CryptoJS.AES.encrypt(''+password, 'beaud@ejima.com').toString();
    },
    comparePwd(evt){
			this.$emit("change", evt);

      if(this.password.length>7) {

				if(this.password != this.confPass) {
          this.pwdNotValide = true;
          return this.errorMessage = "Mot de passe non conforme!";

        } else {
          this.pwdNotValide = false;
          return this.errorMessage = "";

				}

			}
    },
    next(destination){
      this.$router.push({ path: ''+destination });
    }
	}
}
</script>

<style scoped>

</style>
